%global momorel 2
%global cvsdate 20060726

Summary:        OpenGL window and compositing manager
Name:           compiz
Version:        0.0.13
Release:        0.%{cvsdate}.%{momorel}m
License:        GPL
Group:          User Interface/Desktops
Source:         %{name}-%{cvsdate}.tar.bz2
Source2:        Mesa-CVS-20060706.tar.bz2
Source3:        gnome-compizrc
Source4:        gnome-compizrc.desktop
Source10:       mo-nuri.png
Patch1:         mesadec.patch

# Mesa patch
Patch10:        Mesa-6.4.1-x86_64-fixes-1.patch
Patch11:        Mesa-configs.diff

# AIGLX Patch
Patch100: gl-include-inferiors.patch
Patch101: aiglx-defaults.patch
Patch102: tfp-server-extension.patch
Patch103: composite-cube-logo.patch
Patch104: fbconfig-depth-fix.patch
Patch105: glfinish.patch

# Momonga patch
Patch200: momonga-logo.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-root
Requires:       libICE,libSM, libX11, libXau, libXcomposite
Requires:       libXdamage, libXdmcp, libXext, libXfixes 
Requires:       libXrandr, libXrender, libXxf86vm, libdrm
BuildRequires:  pkgconfig, popt
BuildRequires:  mesa-libGL-devel
BuildRequires:	gtk+-devel, libgnomeui-devel
BuildRequires:  cairo-devel, freetype2-devel
BuildRequires:  pango-devel, libwnck-devel, libxml2-devel
BuildRequires:  libsvg-devel, libsvg-cairo-devel
BuildRequires:  libICE-devel,libSM-devel, libX11-devel, libXau-devel
BuildRequires:  libXcomposite-devel, libXdamage-devel, libXdmcp-devel
BuildRequires:  libXext-devel, libXfixes-devel,libXrandr-devel
BuildRequires:  libXrender-devel, libXxf86vm-devel, libdrm-devel
BuildRequires:  control-center-devel

%description
Compiz is an OpenGL compositing manager that use GLX_EXT_texture_from_pixmap
for binding redirected top-level windows to texture objects. It has a flexible
plug-in system and it is designed to run well on most graphics hardware. 


%prep
%setup -q -b 2 -n compiz

%patch1 -p0

%patch100 -p1 -b .gl-include-inferiors
# %patch101 -p1 -b .aiglx-defaults
%patch102 -p1 -b .tfp-server-extension
%patch103 -p1 -b .composite-cube-logo
%patch104 -p1 -b .fbconfig-depth-fix
%patch105 -p1 -b .glfinish

%patch200 -p1 -b .momonga-logo

pushd ../Mesa
%patch10 -p0
%patch11 -p0
popd

%build

##### Mesa
#
pushd ../Mesa
%ifarch %ix86
ln -snf linux-indirect-x86-static configs/current
cd src && make ARCH_FLAGS="-fno-strict-aliasing $RPM_OPT_FLAGS" || exit 1
%endif
%ifarch x86_64
ln -snf linux-indirect-x86-64-static configs/current
cd src && make ARCH_FLAGS="-fno-strict-aliasing $RPM_OPT_FLAGS" || exit 1
%endif
%ifarch ppc
ln -snf linux-indirect-ppc-static configs/current
cd src && make ARCH_FLAGS="-fno-strict-aliasing $RPM_OPT_FLAGS" || exit 1
%endif
%ifnarch ppc x86_64 %ix86
#make linux-dri-static EXTRA_LIB_PATH=-L/usr/%_lib LIB_DIR=\$\(TOP\)/%_lib ARCH_FLAGS="-fno-strict-aliasing" || exit 1ln -snf linux-indirect-static configs/current
cd src && make EXTRA_LIB_PATH=-L/usr/%_lib LIB_DIR=\$\(TOP\)/%_lib ARCH_FLAGS="-fno-strict-aliasing $RPM_OPT_FLAGS" || exit 1
%endif
popd

# Need special static libGL (EXT_texture_from_pixmap) for indirect rendering.
mesagl="`echo $RPM_BUILD_DIR/Mesa/%_lib/libGL.a`"

#autoreconf -fi
./autogen.sh
make distclean
%configure --enable-libsvg-cairo --with-gl-libs="$mesagl -L/usr/lib -lX11 -lXext -lXxf86vm -pthread -ldrm" 
%make

%install
export GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL=0
make DESTDIR=%{buildroot} install
unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL

cp -f %{SOURCE3} %{buildroot}/usr/bin
mkdir -p %{buildroot}/usr/share/gnome/autostart
cp -f %{SOURCE4} %{buildroot}/usr/share/gnome/autostart

rm -f %{buildroot}%{_libdir}/compiz/*.{a,la}
rm -f %{buildroot}%{_libdir}/window-manager-settings/*.{a,la}
# rm -rf %{buildroot}%{_libdir}/pkgconfig %{buildroot}%{_libdir}/include

cp -f %{SOURCE10} %{buildroot}/usr/share/compiz/mo.png

%post
/usr/bin/gconftool-2 --shutdown
export GCONF_CONFIG_SOURCE=`/usr/bin/gconftool-2 --get-default-source`
/usr/bin/gconftool-2 --makefile-install-rule \
		%{_sysconfdir}/gconf/schemas/compiz.schemas > /dev/null

%preun
export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
gconftool-2 --makefile-uninstall-rule \
		%{_sysconfdir}/gconf/schemas/compiz.schemas > /dev/null


%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%files
%defattr(-,root,root)
%{_bindir}/*
%{_includedir}/compiz/*.h
%{_libdir}/compiz/*.so
%{_libdir}/window-manager-settings/*.so
%{_libdir}/pkgconfig/*
%{_datadir}/gnome/wm-properties/*.desktop
%{_datadir}/compiz/*.png
%{_datadir}/gnome/autostart/gnome-compizrc.desktop
%{_datadir}/locale/*/LC_MESSAGES/compiz.mo
%{_sysconfdir}/gconf/schemas/compiz.schemas

%changelog
* Tue Aug  8 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (0.0.13-0.20060726.2m)
- fix mo-nuri.png -> mo.png

* Sun Jul 30 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (0.0.13-0.20060726.1m)
- update 20060726

* Sun Jul 23 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (0.0.13-0.20060722.2m)
- update momonga-logo.patch
-- no use transparent png 

* Sun Jul 23 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (0.0.13-0.20060722.1m)
- update 20060722 

* Wed Jul 19 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (0.0.13-0.20060718.2m)
- cube plugin use "Mo?" logo mark. 

* Tue Jul 18 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (0.0.13-0.20060718.1m)
- update 20060718
- edit gnome-compizrc (support AIGLX)

* Mon Jul 17 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (0.0.13-0.20060705.3m)
- support AIGLX
- usage: compiz --indirect-rendering --strict-binding --replace gconf
-- Patch100: gl-include-inferiors.patch
-- Patch101: aiglx-defaults.patch
-- Patch102: tfp-server-extension.patch
-- Patch103: composite-cube-logo.patch
-- Patch104: fbconfig-depth-fix.patch

* Sat Jul  8 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (0.0.13-0.20060705.2m)
- add Patch7: mesadec.patch

* Fri Jul  7 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (0.0.13-0.20060705.1m)
- update 20060705(cvs)

* Fri Jun 24 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (0.0.13-0.20060621.1m)
- update 20060621

* Mon Jun 19 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (0.0.13-0.20060617.3m)
- disable reload keyboard-config 

* Mon Jun 19 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (0.0.13-0.20060617.2m)
- add post & preun
- static link libGL.a. 

* Sun Jun 18 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (0.0.13-0.20060617.1m)
- update 0.0.13(CVS-20060617)

* Fri Jun 16 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (0.0.12-0.20060602.4m)
- add /usr/bin/gnome-compizrc
-     /usr/share/gnome/autostart/gnome-compiz.desktop

* Fri Jun 16 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (0.0.12-0.20060602.3m)
- remove gnome-xgl-settings.

* Wed Jun 14 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (0.0.12-0.20060602.2m)
- add patch compiz_disable_fbconfig.patch

* Tue Jun 13 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (0.0.12-0.20060602.1m)
- update 0.0.12-20060602

* Sun Jun  4 2006 Mitsuru Shimamura <smbd@momonga-linux.org>
- (0.0.8-2m)
- BuildRequires:  control-center-devel

* Fri Apr  7 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (0.0.8-1m)
- update compiz-20060406

* Fri Mar 31 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (0.0.6-1m)
- initial commit
